/*************************************************************
We decided we would like to help the younger population of the world - children. The children's world today is a
highly complicated one, and also not always the safest. For these purposes we decided
to come up with 'kids Smartwatch’ - a smartwatch that acts as a task manager for
children.
  The types of scenarios are:
  1. Click on the right button in the CPX will send an email message to one of the kid's parents.
  2. The number of homework assignments the kis has - the number of red light that turn on.
  3. If the kid wants remove a task - one click on the left button will turn off one red light.
  4. When all assignments are done - a meldoly will be played.
  5. Click on the right and left buttons at the same time will turn on a 30 seconds stoper. 
     Blue lights will turn on and a melody will be played in the end of the time.
  6.Switch on the switch in the CPX will turn on the flash light.

  We used speaker in order to play a melody when the kid finish the assignments and in the end of the time of the stoper.
  We used the left button in order to remove an assignment.
  We used the right button in order to send an email.
  We used right and left buttons in order to turn on the stoper.
  We used the switch to turn on a flashlight.

  The circuit:
  input: left button, right button, microphone,switch. 
  output: sound, leds.

  Video link: https://youtu.be/NgGGaPp2OLQ
  Instructable link: https://www.instructables.com/SmartWatch-for-Kids/

  Created By:
   Danit Ben Oz 316596394
   Maor Barak 312130727
   Asaf Gurfinkel 305638181
 *************************************************************/

// Template ID, Device Name and Auth Token are provided by the Blynk.Cloud
// See the Device Info tab, or Template settings
#define BLYNK_TEMPLATE_ID "TMPL0xSM4iqh"
#define BLYNK_DEVICE_NAME "New Template"
#define BLYNK_AUTH_TOKEN "b7o0dWfWJkj0hfC7X_x3hXL24AI0k3_3"
#define SHORTEST_DELAY  1000    // milliseconds
#define LONGEST_DELAY   10000   //      "

#include "pitches.h"
// Comment this out to disable prints and save space
#define BLYNK_PRINT SerialUSB
#include <ESP8266_Lib.h>
#include <BlynkSimpleShieldEsp8266.h>
#include <Adafruit_CircuitPlayground.h>

char auth[] = BLYNK_AUTH_TOKEN;

// Your WiFi credentials.
// Set password to "" for open networks.
char ssid[] = "DanitAndYariv";
char pass[] = "danitandyariv123";
int pinValue = 0;
int slides = 0;

const int numNotes = 8;                     // number of notes we are playing
int melody[] = {                            // specific notes in the melody
  NOTE_C4, NOTE_G3, NOTE_G3, NOTE_A3, NOTE_G3, 0, NOTE_B3, NOTE_C4 };

int noteDurations[] = {     // note durations: 4 = quarter note, 8 = eighth note, etc.:
  4, 9, 9, 9, 9, 9, 9, 4 };

// Hardware Serial on Mega, Leonardo, Micro...
#define EspSerial Serial1

// or Software Serial on Uno, Nano...
//#include <SoftwareSerial.h>
//SoftwareSerial EspSerial(2, 3); // RX, TX

// Your ESP8266 baud rate:
#define ESP8266_BAUD 115200

ESP8266 wifi(&EspSerial);

BLYNK_WRITE(V1)
{
  pinValue = param.asInt();
  Serial.println(pinValue);
}

void setup()
{
CircuitPlayground.begin();
  SerialUSB.begin(9600);
  Serial.begin(9600);
  EspSerial.begin(ESP8266_BAUD);
  delay(10);
  CircuitPlayground.irReceiver.enableIRIn(); // Start the receiver
  Blynk.begin(auth, wifi, ssid, pass);

}

void loop()
{
   Blynk.run();
  if(CircuitPlayground.rightButton())
  {
     Blynk.run();
     Blynk.virtualWrite(V0, 1);
     delay(1000);
     Blynk.virtualWrite(V0, 0);
  }
  if(CircuitPlayground.slideSwitch()){

      for (int p=0; p<=10; p++) {
        CircuitPlayground.setPixelColor(p, 0xFFFFFF);    
      }
  }
  else{
      CircuitPlayground.clearPixels();
    }

    if (CircuitPlayground.leftButton() && CircuitPlayground.rightButton()) {
      stoper();
    }
    
    for (int p=0; p<pinValue; p++) {
        CircuitPlayground.setPixelColor(p, 0xFF0000);    
     }
  
    /*if (CircuitPlayground.readCap(A3) > 250)
    {
      for (int p=0; p<10; p++) {
        CircuitPlayground.setPixelColor(p, 0xFFFFFF);  
      }
      delay(1000);
      game();
    }*/
     
    if(CircuitPlayground.leftButton()){
       Blynk.run();
      CircuitPlayground.clearPixels();
      pinValue = pinValue - 1;
      if(pinValue == 0)
      {
          for (int thisNote = 0; thisNote < numNotes; thisNote++) { // play notes of the melody
        // to calculate the note duration, take one second divided by the note type.
        //e.g. quarter note = 1000 / 4, eighth note = 1000/8, etc.
        int noteDuration = 1000 / noteDurations[thisNote];
        CircuitPlayground.playTone(melody[thisNote], noteDuration);
  
        // to distinguish the notes, set a minimum time between them.
        //   the note's duration + 30% seems to work well:
        int pauseBetweenNotes = noteDuration *1.3;
        delay(pauseBetweenNotes);
    }
      }
      Blynk.virtualWrite(V1, pinValue);
      for (int p=0; p<pinValue; p++) {
        CircuitPlayground.setPixelColor(p, 0xFF0000);    
      }
    }


  // Debounce delay
  delay(500);
}

void stoper()
{
    // count down from 30 seconds
    for (int i = 30; i > 0; i--) {
    // turn off a light every three seconds
    if (i % 3 == 0) {
    CircuitPlayground.setPixelColor(10 - (30 - i) / 3, 0X0000FF);
    }
    delay(1000);
    }
    // play a sound twice when the counting ends
    for (int i = 0; i < 2; i++) {
    CircuitPlayground.playTone(2000, 500);
    delay(500);
    CircuitPlayground.playTone(3000, 500);
    delay(500);
    }
}

void game()
{
  if (CircuitPlayground.readCap(A5) > 300) showOutcome(1, true);
  if (CircuitPlayground.readCap(A1) > 700) showOutcome(2, true);
}

void showOutcome(int player, bool winner) {
  int p1, p2;
  uint32_t color;

  // Turn them all off
  CircuitPlayground.clearPixels();

  // Set pixel color
  if (winner) {
    color = 0x00FF00;
  } else {
    color = 0xFF0000;
  }

  // Set pixel range for player
  switch (player) {
    case 1:
      p1 = 0;
      p2 = 4;
      break;
    case 2:
      p1 = 5;
      p2 = 9;
      break;
    default:
      p1 = 0;
      p2 = 9;
  }

  // Show which player won/lost
  for (int p=p1; p<=p2; p++) {
    CircuitPlayground.setPixelColor(p, color);
  }

  // Play a little tune
  if (winner) {
    CircuitPlayground.playTone(800, 200);
    CircuitPlayground.playTone(900, 200);
    CircuitPlayground.playTone(1400, 200);
    CircuitPlayground.playTone(1100, 200);
  } else {
    CircuitPlayground.playTone(200, 1000);
  }

  // Sit here forever
  while (true) {};
}
